package net.sergeych.kiloparsec.adapter

import kotlinx.coroutines.channels.Channel

/**
 * Transport device for inet protocol family with graceful shutdown on [close]
 */
@Suppress("unused")
class InetTransportDevice(
    inputChannel: Channel<UByteArray>,
    outputChannel: Channel<UByteArray>,
    val remoteAddress: NetworkAddress,
    val flush: suspend ()->Unit = {},
    doClose: suspend ()->Unit = {}
) : ProxyDevice(inputChannel, outputChannel, doClose) {
    override fun toString(): String = "@$remoteAddress"
}