package net.sergeych.kiloparsec

import kotlinx.coroutines.test.runTest
import net.sergeych.crypto2.initCrypto
import net.sergeych.kiloparsec.adapter.acceptTcpDevice
import net.sergeych.kiloparsec.adapter.connectTcpDevice
import net.sergeych.mp_logger.Log
import java.net.InetAddress
import kotlin.test.Test
import kotlin.test.assertEquals

class ClientTest {

    @Test
    fun testAddresses() {
        println(InetAddress.getLocalHost())
        println(InetAddress.getByName("localhost"))
        println(InetAddress.getByName("127.0.0.1"))
        println(InetAddress.getByName("mail.ru"))
    }
    @Test
    fun testClient() = runTest {
        initCrypto()
        Log.connectConsole(Log.Level.DEBUG)
        data class Session(
            var data: String
        )

        val cmdSave by command<String,Unit>()
        val cmdLoad by command<Unit,String>()

        val cli = KiloInterface<Session>().apply {
            onConnected { session.data = "start" }
            on(cmdSave) { session.data = it }
            on(cmdLoad) {
                println("load!")
                session.data }
        }
        val server = KiloServer(cli, acceptTcpDevice(17101)) { Session("unknown")}
        val client = KiloClient<Unit> {
            connect { connectTcpDevice("localhost:17101") }
        }
        println(client.call(cmdLoad))

        assertEquals("start", client.call(cmdLoad))
        client.call(cmdSave, "foobar")
        assertEquals("foobar", client.call(cmdLoad))
        server.close()
//        client.close()
    // Todo
    }

    @Test
    fun webSocketTest() = runTest {
//       val server = setupWebsoketServer()
    }
}